#pragma once

#include "prelude.hpp"
#include "../search.hpp"

namespace biscuit
{

template<
	class ParserA, class ParserB
>
struct within
{
	template< class State >
	static bool parse(State &state)
	{
		typename State::iterator_type const cur0 = state.cur;
		typename State::iterator_type const first0 = state.first;
		typename State::iterator_type const last0 = state.last;
		
		if (ParserA::parse(state))
		{
			typename State::iterator_type const curA = state.cur;
			typename State::iterator_type const firstA = state.first;
			typename State::iterator_type const lastA = state.last;
			
			// setup sub range
			state.cur = cur0;
			state.first = cur0;
			state.last = curA;
			
			if (search<ParserB>(state))
			{
				// succeed, pop A's result
				state.cur = curA;
				state.first = firstA;
				state.last = lastA;
				return true;
			}
			else
			{
				// fail, goodby everybody
				state.cur = cur0;
				state.first = first0;
				state.last = last0;
			}
		}

		return false;
	}
};

} // namespace biscuit
